from obitools import bioSeqGenerator,BioSequence
from obitools.align import alignmentReader

def parseFasta(seq):
    title = seq[0].strip()[1:].split(None,1)
    id=title[0]
    if len(title) == 2:
        field = title[1].split('; ')
    else:
        field=[]
    info = dict(x.split('=') for x in field if '=' in x)
    definition = ' '.join([x for x in field if '=' not in x])
    seq=(''.join([x.strip() for x in seq[1:]]))
    return bioSeqGenerator(id, seq, definition,**info)

def fastaIterator(file):
    if isinstance(file,str):
        file = open(file,'ru')
    seq=[]    
    for ligne in file:
        if ligne[0]=='>' and seq:
            yield parseFasta(seq)
            seq=[]
        seq.append(ligne)
        
    yield parseFasta(seq)

def writeFasta(data):
    if isinstance(data, BioSequence):
        data = [data]
    rep = []
    for sequence in data:
        seq = str(sequence)
        frgseq = '\n'.join([seq[x:x+60] for x in xrange(0,len(seq),60)])
        info='; '.join(['%s=%s' % x for x in sequence._info.items()])
        title='>%s %s %s' %(sequence.id,info,sequence.definition)
        rep.append("%s\n%s" % (title,frgseq))
    return '\n'.join(rep)

def fastaAligmentReader(file):
    return alignmentReader(file,fastaIterator)